import abc
from . import simpl as simpl
from abc import ABC, abstractmethod
from typing import List, Tuple, Union

class FilterDelegatePy:
    warning_code: int
    warning_message: str
    preflight: bool
    def __init__(self) -> None: ...
    def notifyStatusMessage(self, message: str) -> None: ...
    def notifyProgressMessage(self, progress: int, message: str) -> None: ...
    def setWarningCondition(self, code: int, message: str) -> None: ...

class Filter(ABC, metaclass=abc.ABCMeta):
    @staticmethod
    @abstractmethod
    def name() -> str: ...
    @staticmethod
    @abstractmethod
    def group_name() -> str: ...
    @staticmethod
    @abstractmethod
    def sub_group_name() -> str: ...
    @staticmethod
    @abstractmethod
    def human_label() -> str: ...
    @staticmethod
    @abstractmethod
    def version() -> str: ...
    @staticmethod
    @abstractmethod
    def compiled_lib_name() -> str: ...
    @abstractmethod
    def setup_parameters(self) -> List[simpl.FilterParameter]: ...
    @abstractmethod
    def data_check(self, dca: simpl.DataContainerArray, delegate: Union[simpl.FilterDelegateCpp, FilterDelegatePy] = ...) -> Tuple[int, str]: ...
    def execute(self, dca: simpl.DataContainerArray, delegate: Union[simpl.FilterDelegateCpp, FilterDelegatePy] = ...) -> Tuple[int, str]: ...
