from typing import Any, List

import dream3d.simpl

class AbaqusHexahedronWriter(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FilePrefix: str
    HourglassStiffness: int
    JobName: str
    OutputPath: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AbaqusSurfaceMeshWriter(dream3d.simpl.AbstractFilter):
    OutputFile: str
    SurfaceMeshFaceLabelsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AvizoRectilinearCoordinateWriter(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    OutputFile: str
    Units: str
    WriteBinaryFile: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AvizoUniformCoordinateWriter(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    OutputFile: str
    Units: str
    WriteBinaryFile: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class DxReader(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: str
    FeatureIdsArrayName: str
    FileWasRead: bool
    InputFile: str
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    VolumeDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class DxWriter(dream3d.simpl.FileWriter):
    AddSurfaceLayer: bool
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FeatureInfoReader(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: dream3d.simpl.DataArrayPath
    CellEulerAnglesArrayName: str
    CellFeatureAttributeMatrixName: str
    CellPhasesArrayName: str
    CreateCellLevelArrays: bool
    FeatureEulerAnglesArrayName: str
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayName: str
    InputFile: str
    RenumberFeatures: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class GBCDTriangleDumper(dream3d.simpl.AbstractFilter):
    FeatureEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    OutputFile: str
    SurfaceMeshFaceAreasArrayPath: dream3d.simpl.DataArrayPath
    SurfaceMeshFaceLabelsArrayPath: dream3d.simpl.DataArrayPath
    SurfaceMeshFaceNormalsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class LosAlamosFFTWriter(dream3d.simpl.FileWriter):
    CellEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class PhReader(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: str
    FeatureIdsArrayName: str
    FileWasRead: bool
    InputFile: str
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    VolumeDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class PhWriter(dream3d.simpl.FileWriter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ReadStlFile(dream3d.simpl.AbstractFilter):
    FaceAttributeMatrixName: str
    FaceNormalsArrayName: str
    ScaleFactor: float
    ScaleOutput: bool
    StlFilePath: str
    SurfaceMeshDataContainerName: dream3d.simpl.DataArrayPath
    VertexAttributeMatrixName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class SPParksDumpReader(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: str
    FeatureIdsArrayName: str
    InputFile: str
    OneBasedArrays: bool
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    VolumeDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class SPParksSitesWriter(dream3d.simpl.FileWriter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class VisualizeGBCDGMT(dream3d.simpl.AbstractFilter):
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    GBCDArrayPath: dream3d.simpl.DataArrayPath
    MisorientationRotation: dream3d.simpl.AxisAngleInput
    OutputFile: str
    PhaseOfInterest: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class VisualizeGBCDPoleFigure(dream3d.simpl.AbstractFilter):
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    GBCDArrayPath: dream3d.simpl.DataArrayPath
    MisorientationRotation: dream3d.simpl.AxisAngleInput
    OutputFile: str
    PhaseOfInterest: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class VtkRectilinearGridWriter(dream3d.simpl.AbstractFilter):
    OutputFile: str
    SelectedDataArrayPaths: List[dream3d.simpl.DataArrayPath]
    WriteBinaryFile: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class VtkStructuredPointsReader(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: str
    InputFile: str
    ReadCellData: bool
    ReadPointData: bool
    VertexAttributeMatrixName: str
    VertexDataContainerName: dream3d.simpl.DataArrayPath
    VolumeDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class WriteStlFile(dream3d.simpl.AbstractFilter):
    GroupByPhase: bool
    OutputStlDirectory: str
    OutputStlPrefix: str
    SurfaceMeshFaceLabelsArrayPath: dream3d.simpl.DataArrayPath
    SurfaceMeshFacePhasesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
