from typing import Any, List

import dream3d.simpl

class CalculateArrayHistogram(dream3d.simpl.AbstractFilter):
    MaxRange: float
    MinRange: float
    NewAttributeMatrixName: str
    NewDataArrayName: str
    NewDataContainer: bool
    NewDataContainerName: dream3d.simpl.DataArrayPath
    Normalize: bool
    NumberOfBins: int
    SelectedArrayPath: dream3d.simpl.DataArrayPath
    UserDefinedRange: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ComputeMomentInvariants2D(dream3d.simpl.AbstractFilter):
    CentralMomentsArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeatureRectArrayPath: dream3d.simpl.DataArrayPath
    NormalizeMomentInvariants: bool
    Omega1ArrayPath: dream3d.simpl.DataArrayPath
    Omega2ArrayPath: dream3d.simpl.DataArrayPath
    SaveCentralMoments: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindAvgScalarValueForFeatures(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NewFeatureArrayArrayPath: dream3d.simpl.DataArrayPath
    SelectedCellArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindBoundaryElementFractions(dream3d.simpl.AbstractFilter):
    BoundaryCellFractionsArrayPath: dream3d.simpl.DataArrayPath
    BoundaryCellsArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindDifferenceMap(dream3d.simpl.AbstractFilter):
    DifferenceMapArrayPath: dream3d.simpl.DataArrayPath
    FirstInputArrayPath: dream3d.simpl.DataArrayPath
    SecondInputArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindEuclideanDistMap(dream3d.simpl.AbstractFilter):
    CalcManhattanDist: bool
    DoBoundaries: bool
    DoQuadPoints: bool
    DoTripleLines: bool
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    GBDistancesArrayName: str
    NearestNeighborsArrayName: str
    QPDistancesArrayName: str
    SaveNearestNeighbors: bool
    TJDistancesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindFeatureClustering(dream3d.simpl.AbstractFilter):
    BiasedFeaturesArrayPath: dream3d.simpl.DataArrayPath
    CellEnsembleAttributeMatrixName: dream3d.simpl.DataArrayPath
    CentroidsArrayPath: dream3d.simpl.DataArrayPath
    ClusteringListArrayName: str
    EquivalentDiametersArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    MaxMinArrayName: str
    NewEnsembleArrayArrayName: str
    NumberOfBins: int
    PhaseNumber: int
    RemoveBiasedFeatures: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindLargestCrossSections(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    LargestCrossSectionsArrayPath: dream3d.simpl.DataArrayPath
    int: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindNeighborhoods(dream3d.simpl.AbstractFilter):
    CentroidsArrayPath: dream3d.simpl.DataArrayPath
    EquivalentDiametersArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    MultiplesOfAverage: float
    NeighborhoodListArrayName: str
    NeighborhoodsArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindNeighbors(dream3d.simpl.AbstractFilter):
    BoundaryCellsArrayName: str
    CellFeatureAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NeighborListArrayName: str
    NumNeighborsArrayName: str
    SharedSurfaceAreaListArrayName: str
    StoreBoundaryCells: bool
    StoreSurfaceFeatures: bool
    SurfaceFeaturesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindNumFeatures(dream3d.simpl.AbstractFilter):
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    NumFeaturesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindShapes(dream3d.simpl.AbstractFilter):
    AspectRatiosArrayName: str
    AxisEulerAnglesArrayName: str
    AxisLengthsArrayName: str
    CellFeatureAttributeMatrixName: dream3d.simpl.DataArrayPath
    CentroidsArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    Omega3sArrayName: str
    VolumesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindSizes(dream3d.simpl.AbstractFilter):
    EquivalentDiametersArrayName: str
    FeatureAttributeMatrixName: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NumElementsArrayName: str
    SaveElementSizes: bool
    VolumesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindSurfaceAreaToVolume(dream3d.simpl.AbstractFilter):
    CalculateSphericity: bool
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NumCellsArrayPath: dream3d.simpl.DataArrayPath
    SphericityArrayName: str
    SurfaceAreaVolumeRatioArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindVolFractions(dream3d.simpl.AbstractFilter):
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    VolFractionsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FitFeatureData(dream3d.simpl.AbstractFilter):
    BiasedFeaturesArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    NewEnsembleArrayArray: dream3d.simpl.DataArrayPath
    RemoveBiasedFeatures: bool
    SelectedFeatureArrayPath: dream3d.simpl.DataArrayPath
    int: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class GenerateEnsembleStatistics(dream3d.simpl.AbstractFilter):
    AspectRatioDistributionFitType: int
    AspectRatiosArrayPath: dream3d.simpl.DataArrayPath
    AvgQuatsArrayPath: dream3d.simpl.DataArrayPath
    AxisEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    BiasedFeaturesArrayPath: dream3d.simpl.DataArrayPath
    CalculateAxisODF: bool
    CalculateCrystallographicStats: bool
    CalculateMDF: bool
    CalculateMorphologicalStats: bool
    CalculateODF: bool
    CellEnsembleAttributeMatrixPath: dream3d.simpl.DataArrayPath
    ComputeAspectRatioDistribution: bool
    ComputeNeighborhoodDistribution: bool
    ComputeOmega3Distribution: bool
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    EquivalentDiametersArrayPath: dream3d.simpl.DataArrayPath
    FeatureEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    IncludeRadialDistFunc: bool
    MaxMinRDFArrayPath: dream3d.simpl.DataArrayPath
    NeighborListArrayPath: dream3d.simpl.DataArrayPath
    NeighborhoodDistributionFitType: int
    NeighborhoodsArrayPath: dream3d.simpl.DataArrayPath
    Omega3DistributionFitType: int
    Omega3sArrayPath: dream3d.simpl.DataArrayPath
    PhaseTypeArray: List[dream3d.simpl.PhaseType]
    PhaseTypeData: List[dream3d.simpl.PhaseType]
    PhaseTypesArrayName: str
    RDFArrayPath: dream3d.simpl.DataArrayPath
    SharedSurfaceAreaListArrayPath: dream3d.simpl.DataArrayPath
    SizeCorrelationResolution: float
    SizeDistributionFitType: int
    StatisticsArrayName: str
    SurfaceFeaturesArrayPath: dream3d.simpl.DataArrayPath
    VolumesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
